//+------------------------------------------------------------------+
//|                                           Andriaus MA+MACD.mq4   |
//|                                           Copyright  2009       | 
//+------------------------------------------------------------------+
#property copyright " Copyright  2009  "
#property link      ""

//----------------------- INCLUDES
#include <stdlib.mqh>

//----------------------- EA PARAMETER
extern string           Expert_Pavadinimas             = "---------- Andriaus MA+MACD";
extern double           Lotas                   =0.01;
extern int              slip                    =5;
extern int              MagicNumeris            = 1234;
extern double           StopLoss                = 200,
                        TakeProfit              = 200;
extern string           TrailingStop_Nustatymai = "---------- Trailing Stop nustatymai";
extern int              TrailingStopType        = 10,
                        TrailingStop            = 400;
extern string           Indicator_Nustatymai    = "---------- Indikatoriu nustatymai";
extern string           MA_Nustatymai           = "---------- MA nustatymai";

extern int              MA_gr_Periodas          = 2;
extern string           MA_gr_TipoAprasas       = "----  0:SMA 1:EMA 2:SMMA 3:LWMA";
extern int              MA_gr_Tipas             = 0;    //0:SMA 1:EMA 2:SMMA 3:LWMA
extern string           MA_gr_KainosAprasas     = "---- 0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted";
extern int              MA_gr_Kaina             = 0,    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted
                        MA_gr_Poslinkis         = 0,
                        
                        MA_let_Periodas         = 19;
extern string           MA_let_TipoAprasas      = "----  0:SMA 1:EMA 2:SMMA 3:LWMA";
extern int              MA_let_Tipas            = 0;    //0:SMA 1:EMA 2:SMMA 3:LWMA
extern string           MA_let_KainosAprasas    = "---- 0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted";
extern int              MA_let_Kaina            = 0,    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted
                        MA_let_Poslinkis        = 0;
                        
extern string           MACD_Nustatymai         = "---------- MACD nustatymai";
                        
extern int              Greitas_EMA             = 5;
extern int              Letas_EMA               = 8;
extern int              MACD_SMA                = 1;
extern string           MACD_KainosAprasas    = "---- 0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted";
extern int              MACD_Kaina            = 0,    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted   

 

 
//----------------------------------------------------------------------  
 
int start()
  {
  int kk_1,kk_2,gle;
  //if(Bars<100 || IsTradeAllowed()==false || Year()!=2009 || AccountFreeMargin()<AccountBalance()*0.5) return;  
   int ma_b,ma_s,
       macd_b,macd_s;
   int ticket1,ticket2; 
            
//Indikatoriu kintamieji
 
//double iMA(	string symbol, int timeframe, int period, int ma_shift, int ma_method, int applied_price, int shift)
double ma_let0 =iMA(NULL,0,MA_let_Periodas, MA_let_Poslinkis,MA_let_Tipas,MA_let_Kaina,0);
double ma_gr0  =iMA(NULL,0,MA_gr_Periodas,  MA_gr_Poslinkis, MA_gr_Tipas, MA_gr_Kaina, 0);         
double ma_let1 =iMA(NULL,0,MA_let_Periodas, MA_let_Poslinkis,MA_let_Tipas,MA_let_Kaina,1);
double ma_gr1  =iMA(NULL,0,MA_gr_Periodas,  MA_gr_Poslinkis, MA_gr_Tipas, MA_gr_Kaina, 1);
double ma_let2 =iMA(NULL,0,MA_let_Periodas, MA_let_Poslinkis,MA_let_Tipas,MA_let_Kaina,2);
double ma_gr2  =iMA(NULL,0,MA_gr_Periodas,  MA_gr_Poslinkis, MA_gr_Tipas, MA_gr_Kaina, 2);

//double iMACD(	string symbol, int timeframe, int fast_ema_period, int slow_ema_period, int signal_period, int applied_price, int mode, int shift)
double macd_1  =iMACD(NULL,0,Greitas_EMA,Letas_EMA ,MACD_SMA,MACD_Kaina,MODE_MAIN,1);
double macd_2  =iMACD(NULL,0,Greitas_EMA,Letas_EMA ,MACD_SMA,MACD_Kaina,MODE_MAIN,2);
 
// MA prekybine salyga

 if(ma_let2>ma_gr2 && ma_gr1>ma_let1)ma_b=1;
 if(ma_let2<ma_gr2 && ma_gr1<ma_let1)ma_s=1;
 
// MACD prekybine salyga
 
 if(macd_2<=0 && macd_1>0)macd_b=1;
 if(macd_2>=0 && macd_1<0)macd_s=1; 

//Pirkimas

 if(ma_gr0>ma_gr1 && ma_b==1 && macd_b==1)
 {  
  kk_1=0;
    while(ticket1==-1 && kk_1<3)
	{
   ticket1=OrderSend(Symbol(),OP_BUY,Lotas ,Ask,slip,Bid-StopLoss*Point,Ask+TakeProfit*Point,"BUY",MagicNumeris,0,Green);  
      if (ticket1==-1)
               {
               gle=GetLastError();
               kk_1++;               
               Print("Klaidos kodas ?",gle," BUY bandymu skaicius ",kk_1);
               Sleep(6000);
               RefreshRates();   
               }
              
     } 
     kk_2=0;  
   while(ticket2==-1 && kk_2<3)
	{	   
   ticket2=OrderSend(Symbol(),OP_BUY,Lotas ,Ask,slip,Bid-StopLoss*Point,0,"BUY",MagicNumeris+1,0,Green); 
     if (ticket2==-1)
               {
               gle=GetLastError();//klaidos kodas
               kk_2++;               
               Print("Klaidos kodas ?",gle," BUY bandymu skaicius ",kk_2);
               Sleep(6000);
               RefreshRates(); 
				}
				
	}			
 ma_b   =0;
 macd_b =0;
 }
 
 //Pardavimas
 
 if(ma_gr0<ma_gr1 && ma_s==1 && macd_s==1)
 {  
   if(ticket1<1)        
   {  
	ticket1=OrderSend(Symbol(),OP_SELL,Lotas ,Bid,slip,Bid+StopLoss*Point,Bid+TakeProfit*Point,"SELL",MagicNumeris,0,Red);  
      if(ticket1<0)
       {
        Print("OrderSend failed with error #",GetLastError());
        return(0);
		}
	}
   if(ticket2<1)
	{   
	ticket2=OrderSend(Symbol(),OP_SELL,Lotas ,Bid,slip,Bid+StopLoss*Point,0,"SELL",MagicNumeris+1,0,Red); 
      if(ticket2<0)
       {
        Print("OrderSend failed with error #",GetLastError());
        return(0);
		}
	}
 ma_s   =0;
 macd_s =0;
 }
     return(0);
}                                                                                   




